/*
 * Mangrove Server API
 *
 * Submit and retrieve reviews, as well as aggregate statistics about reviews. More information about the values and types can be found in the [Open Reviews Standard](https://mangrove.reviews/standard). For more description and example usage see [Mangrove Demo UI](https://mangrove.reviews) and [Mangrove Client JS Library](https://js.mangrove.reviews/) for a JavaScript wrapper of this API.
 *
 * The version of the OpenAPI document: 0.1.1
 *
 * Generated by: https://openapi-generator.tech
 */
use serde_derive::{Deserialize, Serialize};

use reqwest;

use super::{configuration, Error};
use crate::apis::ResponseContent;

/// struct for typed errors of method [`get_reviews_by_coordinates`]
#[derive(Debug, Clone, Serialize, Deserialize)]
#[serde(untagged)]
pub enum GetReviewsByCoordinatesError {
    Status400(String),
    Status500(String),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`batch_post`]
#[derive(Debug, Clone, Serialize, Deserialize)]
#[serde(untagged)]
pub enum BatchPostError {
    Status400(String),
    Status500(String),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`issuer_pem_get`]
#[derive(Debug, Clone, Serialize, Deserialize)]
#[serde(untagged)]
pub enum IssuerPemGetError {
    Status400(String),
    Status500(String),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`review_signature_get`]
#[derive(Debug, Clone, Serialize, Deserialize)]
#[serde(untagged)]
pub enum ReviewSignatureGetError {
    Status400(String),
    Status500(String),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`reviews_get`]
#[derive(Debug, Clone, Serialize, Deserialize)]
#[serde(untagged)]
pub enum ReviewsGetError {
    Status400(String),
    Status500(String),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`subject_sub_get`]
#[derive(Debug, Clone, Serialize, Deserialize)]
#[serde(untagged)]
pub enum SubjectSubGetError {
    Status400(String),
    Status500(String),
    UnknownValue(serde_json::Value),
}

/// struct for typed errors of method [`submit_jwt_review_put`]
#[derive(Debug, Clone, Serialize, Deserialize, PartialEq)]
#[serde(untagged)]
pub enum SubmitJwtReviewPutError {
    Status400(String),
    Status500(String),
    UnknownValue(serde_json::Value),
}

/// Request reviews within provided coordinates.
pub async fn get_reviews_by_coordinates(
    configuration: &configuration::Configuration,
    xmin: f32,
    ymin: f32,
    xmax: f32,
    ymax: f32,
) -> Result<crate::models::Reviews, Error<GetReviewsByCoordinatesError>> {
    let local_var_configuration = configuration;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!("{}/geo", local_var_configuration.base_path);
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    local_var_req_builder = local_var_req_builder.query(&[("xmin", &xmin.to_string())]);
    local_var_req_builder = local_var_req_builder.query(&[("ymin", &ymin.to_string())]);
    local_var_req_builder = local_var_req_builder.query(&[("xmax", &xmax.to_string())]);
    local_var_req_builder = local_var_req_builder.query(&[("ymax", &ymax.to_string())]);
    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<GetReviewsByCoordinatesError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Retrieve aggregates for multiple subjects or issuers.
pub async fn batch_post(
    configuration: &configuration::Configuration,
    batch_query: crate::models::BatchQuery,
) -> Result<crate::models::BatchReturn, Error<BatchPostError>> {
    let local_var_configuration = configuration;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!("{}/batch", local_var_configuration.base_path);
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::POST, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }
    local_var_req_builder = local_var_req_builder.json(&batch_query);

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<BatchPostError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Request aggregate information about the reviewer.
pub async fn issuer_pem_get(
    configuration: &configuration::Configuration,
    pem: &str,
) -> Result<crate::models::Issuer, Error<IssuerPemGetError>> {
    let local_var_configuration = configuration;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/issuer/{pem}",
        local_var_configuration.base_path,
        pem = crate::apis::urlencode(pem)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<IssuerPemGetError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Request review with the specified signature.
pub async fn review_signature_get(
    configuration: &configuration::Configuration,
    signature: &str,
) -> Result<crate::models::Review, Error<ReviewSignatureGetError>> {
    let local_var_configuration = configuration;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/review/{signature}",
        local_var_configuration.base_path,
        signature = crate::apis::urlencode(signature)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<ReviewSignatureGetError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Request reviews matching the provided query.
pub async fn reviews_get(
    configuration: &configuration::Configuration,
    q: Option<&str>,
    signature: Option<&str>,
    kid: Option<&str>,
    iat: Option<i64>,
    gt_iat: Option<f32>,
    sub: Option<&str>,
    rating: Option<i64>,
    opinion: Option<&str>,
    limit: Option<f32>,
    opinionated: Option<bool>,
    examples: Option<bool>,
    issuers: Option<bool>,
    maresi_subjects: Option<bool>,
) -> Result<crate::models::Reviews, Error<ReviewsGetError>> {
    let local_var_configuration = configuration;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!("{}/reviews", local_var_configuration.base_path);
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_str) = q {
        local_var_req_builder = local_var_req_builder.query(&[("q", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = signature {
        local_var_req_builder =
            local_var_req_builder.query(&[("signature", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = kid {
        local_var_req_builder = local_var_req_builder.query(&[("kid", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = iat {
        local_var_req_builder = local_var_req_builder.query(&[("iat", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = gt_iat {
        local_var_req_builder =
            local_var_req_builder.query(&[("gt_iat", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = sub {
        local_var_req_builder = local_var_req_builder.query(&[("sub", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = rating {
        local_var_req_builder =
            local_var_req_builder.query(&[("rating", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = opinion {
        local_var_req_builder =
            local_var_req_builder.query(&[("opinion", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = limit {
        local_var_req_builder =
            local_var_req_builder.query(&[("limit", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = opinionated {
        local_var_req_builder =
            local_var_req_builder.query(&[("opinionated", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = examples {
        local_var_req_builder =
            local_var_req_builder.query(&[("examples", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = issuers {
        local_var_req_builder =
            local_var_req_builder.query(&[("issuers", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_str) = maresi_subjects {
        local_var_req_builder =
            local_var_req_builder.query(&[("maresi_subjects", &local_var_str.to_string())]);
    }
    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<ReviewsGetError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Request aggregate information about the subject.
pub async fn subject_sub_get(
    configuration: &configuration::Configuration,
    sub: &str,
) -> Result<crate::models::Subject, Error<SubjectSubGetError>> {
    let local_var_configuration = configuration;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/subject/{sub}",
        local_var_configuration.base_path,
        sub = crate::apis::urlencode(sub)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::GET, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<SubjectSubGetError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}

/// Submit a new review.
pub async fn submit_jwt_review_put(
    configuration: &configuration::Configuration,
    jwt_review: &str,
) -> Result<bool, Error<SubmitJwtReviewPutError>> {
    let local_var_configuration = configuration;

    let local_var_client = &local_var_configuration.client;

    let local_var_uri_str = format!(
        "{}/submit/{jwt_review}",
        local_var_configuration.base_path,
        jwt_review = crate::apis::urlencode(jwt_review)
    );
    let mut local_var_req_builder =
        local_var_client.request(reqwest::Method::PUT, local_var_uri_str.as_str());

    if let Some(ref local_var_user_agent) = local_var_configuration.user_agent {
        local_var_req_builder =
            local_var_req_builder.header(reqwest::header::USER_AGENT, local_var_user_agent.clone());
    }

    let local_var_req = local_var_req_builder.build()?;
    let local_var_resp = local_var_client.execute(local_var_req).await?;

    let local_var_status = local_var_resp.status();
    let local_var_content = local_var_resp.text().await?;

    if !local_var_status.is_client_error() && !local_var_status.is_server_error() {
        serde_json::from_str(&local_var_content).map_err(Error::from)
    } else {
        let local_var_entity: Option<SubmitJwtReviewPutError> =
            serde_json::from_str(&local_var_content).ok();
        let local_var_error = ResponseContent {
            status: local_var_status,
            content: local_var_content,
            entity: local_var_entity,
        };
        Err(Error::ResponseError(local_var_error))
    }
}
